#include "main.h"
#include "hslee_spi.h"
#include "hslee_delay.h"

void Init_SPI1()
{
	
}

void Init_SPI2()
{
	int rData = SPI2BUF;    //Clears receive buffer
	IFS0CLR = 0x03800000;   //Clears any existing event (rx / tx/ fault interrupt)
	SPI2STATCLR = 0x40;      //Clears overflow
	SpiChnOpen(2, SPI_CON_MSTEN | SPI_CON_MODE16 | SPI_CON_ON | SPI_CON_CKP, SPI_SCK_CLOCK);// divide fpb by 1024, configure the I/O ports.
	Delayms(16);  // ʱȭǴµ 16ms  ʿϴ...
}

unsigned int Trans_spi2(unsigned int tx_data)
{
	unsigned int receive;
    putcSPI2(tx_data);                 //Sends hex data 0xAA to slave	
	Delayus(SPI_SCK_CLOCK * 2);
	SpiChnClrIntFlags(2);            //Clear interrupt flags (Tx / Rx buffers empty)

    receive = SPI2BUF;            //Read SP1BUF (dummy read)
    SPI2BUF = 0x0000;                  //Write SP1BUF- sets Tx flag, if not done read will not clock
    receive = getcSPI2();            //Generates clock and reads SDO
    return receive;
}	


float Get_SPISensor(unsigned char ch)
{	
	unsigned int receive[5] = {0,0,0,0,0};
	unsigned int ang = 0;
	unsigned int check_sum = 0;
	float ang_f = 0.0;
    
	switch(ch)
	{
		case 0:
			SS_0 = 0;
			break;
		case 1:
			SS_1 = 0;
			break;
		case 2:
			SS_2 = 0;
			break;
		case 3:
			SS_3 = 0;
			break;
	}		
	
	receive[0] = Trans_spi2(0xAAFF);
	receive[1] = Trans_spi2(0xFFFF);
	receive[2] = Trans_spi2(0xFFFF);
	receive[3] = Trans_spi2(0xFFFF);
	receive[4] = Trans_spi2(0xFFFF);
	
	switch(ch)
	{
		case 0:
			SS_0 = 1;
			break;
		case 1:
			SS_1 = 1;
			break;
		case 2:
			SS_2 = 1;
			break;
		case 3:
			SS_3 = 1;
			break;
	}	
	
	//Delayms(2);//HIְ..1.5ms .(̺갡. ۵Ǵ ð..)
	
	ang = ((~receive[1] & 0x00ff) << 8) | ((receive[1] & 0xff00) >> 8);
	check_sum = ang & 0x0003;
	if(check_sum == 0x0001)
	{
		ang =  ang >> 2 & 0x3fff;
		ang_f = PCS360_RES * (float)ang;
		ang_f = (ang_f - 36) * 1.25;
		
		if(ang_f >= 180)
			ang_f = ang_f - 360;
			
    	return ang_f;		
	}   
	return 0.0f;
}
