#include "main.h"
#include "hslee_uart.h"


void Init_Uart1(int baud)
{
	OpenUART1(UART_EN, UART_RX_ENABLE | UART_TX_ENABLE, SYS_FREQ/16/baud-1);
	ConfigIntUART1(UART_INT_PR5 | UART_RX_INT_EN);
}


void Init_Uart2(int baud)
{
	OpenUART2(UART_EN, UART_RX_ENABLE | UART_TX_ENABLE, SYS_FREQ/16/baud-1);
	ConfigIntUART2(UART_INT_PR3 | UART_RX_INT_EN);

/*
	UARTConfigure(UART2, UART_ENABLE_PINS_TX_RX_ONLY);
    UARTSetFifoMode(UART2, UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY);
    UARTSetLineControl(UART2, UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1);
    UARTSetDataRate(UART2, SYS_FREQ, 115200);
    UARTEnable(UART2, UART_ENABLE_FLAGS(UART_PERIPHERAL | UART_RX | UART_TX));
*/  
}


void TxData1(unsigned char data)
{
	while(!UARTTransmitterIsReady(UART1));
	UARTSendDataByte(UART1, data);
	while(!UARTTransmissionHasCompleted(UART1));
}    
void TxString1(char* data)
{
	UART1_EN = 1;
	putsUART1(data);
	UART1_EN = 0;
}


void TxData2(unsigned char data)
{
    while(!UARTTransmitterIsReady(UART2)) ;
	UARTSendDataByte(UART2, data);
	while(!UARTTransmissionHasCompleted(UART2)) ;
	//putcUART2((unsigned char)data);
}    
void TxString2(char* data)
{
	UART2_EN;
	putsUART1(data);
	UART2_DI;
}




void UART1_SendDataBuffer(const char *buffer, UINT8 size)
{
    while(size--)
    {
        while(!UARTTransmitterIsReady(UART1));
        UARTSendDataByte(UART1, *buffer++);
    }
    while(!UARTTransmissionHasCompleted(UART1));
}


UINT8 UART1_GetDataBuffer(char *buffer, UINT8 max_size)
{
    UINT8 num_char;
    num_char = 0;

    while(num_char < max_size)
    {
        UINT8 character;


        while(!UARTReceivedDataIsAvailable(UART1));
        character = UARTGetDataByte(UART1);

/*		
		while(!DataRdyUART1()); 
      	character = (char)ReadUART1(); 
*/
		*buffer = character;
        buffer++;
        num_char++;
        
        if(character == ';')
            break;
    }
    return num_char;
    
}

void UART2_SendDataBuffer(const char *buffer, UINT8 size)
{
    while(size--)
    {
        while(!UARTTransmitterIsReady(UART2));
        UARTSendDataByte(UART2, *buffer++);
    }
    while(!UARTTransmissionHasCompleted(UART2));
}

UINT8 UART2_GetDataBuffer(char *buffer, UINT8 max_size)
{
    UINT8 num_char;
    num_char = 0;

    while(num_char < max_size)
    {
        UINT8 character;


        while(!UARTReceivedDataIsAvailable(UART2));
        character = UARTGetDataByte(UART2);

/*		
		while(!DataRdyUART2()); 
      	character = (char)ReadUART2(); 
*/
		*buffer = character;
        buffer++;
        num_char++;
        
        if(character == ';')
            break;
    }
    return num_char;
    
}

